unit schArticulosServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, schArticulosClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_ArticulosDelta = '{3C86B4D6-46CB-46C0-A38D-92B71233360F}';
  RID_Articulos_RefreshDelta = '{1226EC42-63CA-45D5-9854-A19043873F47}';
  RID_ArticulosParaClienteDelta = '{A6BC0C26-3A03-4434-82D3-07521A7956C4}';

type
  { IArticulosDelta }
  IArticulosDelta = interface(IArticulos)
  ['{3C86B4D6-46CB-46C0-A38D-92B71233360F}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldREFERENCIAValue : String;
    function GetOldDESCRIPCIONValue : String;
    function GetOldFAMILIAValue : String;
    function GetOldIMAGENValue : IROStream;
    function GetOldCOMISIONABLEValue : Integer;
    function GetOldFECHA_ALTAValue : DateTime;
    function GetOldFECHA_MODIFICACIONValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldREFERENCIA_PROVValue : String;
    function GetOldPRECIO_COSTEValue : Float;
    function GetOldPRECIO_PORTEValue : Float;
    function GetOldDESCUENTOValue : Float;
    function GetOldPRECIO_NETOValue : Float;
    function GetOldINVENTARIABLEValue : Integer;
    function GetOldID_PROVEEDORValue : Integer;
    function GetOldNOMBRE_PROVEEDORValue : String;
    function GetOldELIMINADOValue : Integer;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldFAMILIA : String read GetOldFAMILIAValue;
    property OldIMAGEN : IROStream read GetOldIMAGENValue;
    property OldCOMISIONABLE : Integer read GetOldCOMISIONABLEValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property OldPRECIO_COSTE : Float read GetOldPRECIO_COSTEValue;
    property OldPRECIO_PORTE : Float read GetOldPRECIO_PORTEValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property OldPRECIO_NETO : Float read GetOldPRECIO_NETOValue;
    property OldINVENTARIABLE : Integer read GetOldINVENTARIABLEValue;
    property OldID_PROVEEDOR : Integer read GetOldID_PROVEEDORValue;
    property OldNOMBRE_PROVEEDOR : String read GetOldNOMBRE_PROVEEDORValue;
    property OldELIMINADO : Integer read GetOldELIMINADOValue;
  end;

  { TArticulosBusinessProcessorRules }
  TArticulosBusinessProcessorRules = class(TDABusinessProcessorRules, IArticulos, IArticulosDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetOldIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetFAMILIAValue: String; virtual;
    function GetOldFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetIMAGENValue: IROStream; virtual;
    function GetOldIMAGENValue: IROStream; virtual;
    procedure SetIMAGENValue(const aValue: IROStream); virtual;
    function GetCOMISIONABLEValue: Integer; virtual;
    function GetOldCOMISIONABLEValue: Integer; virtual;
    procedure SetCOMISIONABLEValue(const aValue: Integer); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    function GetOldFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    function GetOldFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVValue: String; virtual;
    function GetOldREFERENCIA_PROVValue: String; virtual;
    procedure SetREFERENCIA_PROVValue(const aValue: String); virtual;
    function GetPRECIO_COSTEValue: Float; virtual;
    function GetOldPRECIO_COSTEValue: Float; virtual;
    procedure SetPRECIO_COSTEValue(const aValue: Float); virtual;
    function GetPRECIO_PORTEValue: Float; virtual;
    function GetOldPRECIO_PORTEValue: Float; virtual;
    procedure SetPRECIO_PORTEValue(const aValue: Float); virtual;
    function GetDESCUENTOValue: Float; virtual;
    function GetOldDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetPRECIO_NETOValue: Float; virtual;
    function GetOldPRECIO_NETOValue: Float; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Float); virtual;
    function GetINVENTARIABLEValue: Integer; virtual;
    function GetOldINVENTARIABLEValue: Integer; virtual;
    procedure SetINVENTARIABLEValue(const aValue: Integer); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    function GetOldID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetNOMBRE_PROVEEDORValue: String; virtual;
    function GetOldNOMBRE_PROVEEDORValue: String; virtual;
    procedure SetNOMBRE_PROVEEDORValue(const aValue: String); virtual;
    function GetELIMINADOValue: Integer; virtual;
    function GetOldELIMINADOValue: Integer; virtual;
    procedure SetELIMINADOValue(const aValue: Integer); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property OldID : Integer read GetOldIDValue;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property FAMILIA : String read GetFAMILIAValue write SetFAMILIAValue;
    property OldFAMILIA : String read GetOldFAMILIAValue;
    property IMAGEN : IROStream read GetIMAGENValue write SetIMAGENValue;
    property OldIMAGEN : IROStream read GetOldIMAGENValue;
    property COMISIONABLE : Integer read GetCOMISIONABLEValue write SetCOMISIONABLEValue;
    property OldCOMISIONABLE : Integer read GetOldCOMISIONABLEValue;
    property FECHA_ALTA : DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property FECHA_MODIFICACION : DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property REFERENCIA_PROV : String read GetREFERENCIA_PROVValue write SetREFERENCIA_PROVValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property PRECIO_COSTE : Float read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property OldPRECIO_COSTE : Float read GetOldPRECIO_COSTEValue;
    property PRECIO_PORTE : Float read GetPRECIO_PORTEValue write SetPRECIO_PORTEValue;
    property OldPRECIO_PORTE : Float read GetOldPRECIO_PORTEValue;
    property DESCUENTO : Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property PRECIO_NETO : Float read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property OldPRECIO_NETO : Float read GetOldPRECIO_NETOValue;
    property INVENTARIABLE : Integer read GetINVENTARIABLEValue write SetINVENTARIABLEValue;
    property OldINVENTARIABLE : Integer read GetOldINVENTARIABLEValue;
    property ID_PROVEEDOR : Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property OldID_PROVEEDOR : Integer read GetOldID_PROVEEDORValue;
    property NOMBRE_PROVEEDOR : String read GetNOMBRE_PROVEEDORValue write SetNOMBRE_PROVEEDORValue;
    property OldNOMBRE_PROVEEDOR : String read GetOldNOMBRE_PROVEEDORValue;
    property ELIMINADO : Integer read GetELIMINADOValue write SetELIMINADOValue;
    property OldELIMINADO : Integer read GetOldELIMINADOValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IArticulos_RefreshDelta }
  IArticulos_RefreshDelta = interface(IArticulos_Refresh)
  ['{1226EC42-63CA-45D5-9854-A19043873F47}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldFECHA_ALTAValue : DateTime;
    function GetOldFECHA_MODIFICACIONValue : DateTime;
    function GetOldREFERENCIA_PROVValue : String;
    function GetOldPRECIO_COSTEValue : Float;
    function GetOldPRECIO_PORTEValue : Float;
    function GetOldDESCUENTOValue : Float;
    function GetOldPRECIO_NETOValue : Float;
    function GetOldINVENTARIABLEValue : Integer;
    function GetOldID_PROVEEDORValue : Integer;
    function GetOldNOMBRE_PROVEEDORValue : String;
    function GetOldELIMINADOValue : Integer;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property OldPRECIO_COSTE : Float read GetOldPRECIO_COSTEValue;
    property OldPRECIO_PORTE : Float read GetOldPRECIO_PORTEValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property OldPRECIO_NETO : Float read GetOldPRECIO_NETOValue;
    property OldINVENTARIABLE : Integer read GetOldINVENTARIABLEValue;
    property OldID_PROVEEDOR : Integer read GetOldID_PROVEEDORValue;
    property OldNOMBRE_PROVEEDOR : String read GetOldNOMBRE_PROVEEDORValue;
    property OldELIMINADO : Integer read GetOldELIMINADOValue;
  end;

  { TArticulos_RefreshBusinessProcessorRules }
  TArticulos_RefreshBusinessProcessorRules = class(TDABusinessProcessorRules, IArticulos_Refresh, IArticulos_RefreshDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetOldIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    function GetOldFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    function GetOldFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetREFERENCIA_PROVValue: String; virtual;
    function GetOldREFERENCIA_PROVValue: String; virtual;
    procedure SetREFERENCIA_PROVValue(const aValue: String); virtual;
    function GetPRECIO_COSTEValue: Float; virtual;
    function GetOldPRECIO_COSTEValue: Float; virtual;
    procedure SetPRECIO_COSTEValue(const aValue: Float); virtual;
    function GetPRECIO_PORTEValue: Float; virtual;
    function GetOldPRECIO_PORTEValue: Float; virtual;
    procedure SetPRECIO_PORTEValue(const aValue: Float); virtual;
    function GetDESCUENTOValue: Float; virtual;
    function GetOldDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetPRECIO_NETOValue: Float; virtual;
    function GetOldPRECIO_NETOValue: Float; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Float); virtual;
    function GetINVENTARIABLEValue: Integer; virtual;
    function GetOldINVENTARIABLEValue: Integer; virtual;
    procedure SetINVENTARIABLEValue(const aValue: Integer); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    function GetOldID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetNOMBRE_PROVEEDORValue: String; virtual;
    function GetOldNOMBRE_PROVEEDORValue: String; virtual;
    procedure SetNOMBRE_PROVEEDORValue(const aValue: String); virtual;
    function GetELIMINADOValue: Integer; virtual;
    function GetOldELIMINADOValue: Integer; virtual;
    procedure SetELIMINADOValue(const aValue: Integer); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property OldID : Integer read GetOldIDValue;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property FECHA_ALTA : DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property FECHA_MODIFICACION : DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property REFERENCIA_PROV : String read GetREFERENCIA_PROVValue write SetREFERENCIA_PROVValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property PRECIO_COSTE : Float read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property OldPRECIO_COSTE : Float read GetOldPRECIO_COSTEValue;
    property PRECIO_PORTE : Float read GetPRECIO_PORTEValue write SetPRECIO_PORTEValue;
    property OldPRECIO_PORTE : Float read GetOldPRECIO_PORTEValue;
    property DESCUENTO : Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property PRECIO_NETO : Float read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property OldPRECIO_NETO : Float read GetOldPRECIO_NETOValue;
    property INVENTARIABLE : Integer read GetINVENTARIABLEValue write SetINVENTARIABLEValue;
    property OldINVENTARIABLE : Integer read GetOldINVENTARIABLEValue;
    property ID_PROVEEDOR : Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property OldID_PROVEEDOR : Integer read GetOldID_PROVEEDORValue;
    property NOMBRE_PROVEEDOR : String read GetNOMBRE_PROVEEDORValue write SetNOMBRE_PROVEEDORValue;
    property OldNOMBRE_PROVEEDOR : String read GetOldNOMBRE_PROVEEDORValue;
    property ELIMINADO : Integer read GetELIMINADOValue write SetELIMINADOValue;
    property OldELIMINADO : Integer read GetOldELIMINADOValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IArticulosParaClienteDelta }
  IArticulosParaClienteDelta = interface(IArticulosParaCliente)
  ['{A6BC0C26-3A03-4434-82D3-07521A7956C4}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldREFERENCIAValue : String;
    function GetOldDESCRIPCIONValue : String;
    function GetOldFAMILIAValue : String;
    function GetOldIMAGENValue : IROStream;
    function GetOldCOMISIONABLEValue : Integer;
    function GetOldFECHA_ALTAValue : DateTime;
    function GetOldFECHA_MODIFICACIONValue : DateTime;
    function GetOldUSUARIOValue : String;
    function GetOldREFERENCIA_PROVValue : String;
    function GetOldPRECIO_COSTEValue : Float;
    function GetOldPRECIO_PORTEValue : Float;
    function GetOldDESCUENTOValue : Float;
    function GetOldPRECIO_NETOValue : Float;
    function GetOldID_PROVEEDORValue : Integer;
    function GetOldINVENTARIABLEValue : Integer;
    function GetOldNOMBRE_PROVEEDORValue : String;
    function GetOldELIMINADOValue : Integer;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldFAMILIA : String read GetOldFAMILIAValue;
    property OldIMAGEN : IROStream read GetOldIMAGENValue;
    property OldCOMISIONABLE : Integer read GetOldCOMISIONABLEValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property OldPRECIO_COSTE : Float read GetOldPRECIO_COSTEValue;
    property OldPRECIO_PORTE : Float read GetOldPRECIO_PORTEValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property OldPRECIO_NETO : Float read GetOldPRECIO_NETOValue;
    property OldID_PROVEEDOR : Integer read GetOldID_PROVEEDORValue;
    property OldINVENTARIABLE : Integer read GetOldINVENTARIABLEValue;
    property OldNOMBRE_PROVEEDOR : String read GetOldNOMBRE_PROVEEDORValue;
    property OldELIMINADO : Integer read GetOldELIMINADOValue;
  end;

  { TArticulosParaClienteBusinessProcessorRules }
  TArticulosParaClienteBusinessProcessorRules = class(TDABusinessProcessorRules, IArticulosParaCliente, IArticulosParaClienteDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetOldIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    function GetOldREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetFAMILIAValue: String; virtual;
    function GetOldFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetIMAGENValue: IROStream; virtual;
    function GetOldIMAGENValue: IROStream; virtual;
    procedure SetIMAGENValue(const aValue: IROStream); virtual;
    function GetCOMISIONABLEValue: Integer; virtual;
    function GetOldCOMISIONABLEValue: Integer; virtual;
    procedure SetCOMISIONABLEValue(const aValue: Integer); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    function GetOldFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    function GetOldFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    function GetOldUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVValue: String; virtual;
    function GetOldREFERENCIA_PROVValue: String; virtual;
    procedure SetREFERENCIA_PROVValue(const aValue: String); virtual;
    function GetPRECIO_COSTEValue: Float; virtual;
    function GetOldPRECIO_COSTEValue: Float; virtual;
    procedure SetPRECIO_COSTEValue(const aValue: Float); virtual;
    function GetPRECIO_PORTEValue: Float; virtual;
    function GetOldPRECIO_PORTEValue: Float; virtual;
    procedure SetPRECIO_PORTEValue(const aValue: Float); virtual;
    function GetDESCUENTOValue: Float; virtual;
    function GetOldDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetPRECIO_NETOValue: Float; virtual;
    function GetOldPRECIO_NETOValue: Float; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Float); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    function GetOldID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetINVENTARIABLEValue: Integer; virtual;
    function GetOldINVENTARIABLEValue: Integer; virtual;
    procedure SetINVENTARIABLEValue(const aValue: Integer); virtual;
    function GetNOMBRE_PROVEEDORValue: String; virtual;
    function GetOldNOMBRE_PROVEEDORValue: String; virtual;
    procedure SetNOMBRE_PROVEEDORValue(const aValue: String); virtual;
    function GetELIMINADOValue: Integer; virtual;
    function GetOldELIMINADOValue: Integer; virtual;
    procedure SetELIMINADOValue(const aValue: Integer); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property OldID : Integer read GetOldIDValue;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property REFERENCIA : String read GetREFERENCIAValue write SetREFERENCIAValue;
    property OldREFERENCIA : String read GetOldREFERENCIAValue;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property FAMILIA : String read GetFAMILIAValue write SetFAMILIAValue;
    property OldFAMILIA : String read GetOldFAMILIAValue;
    property IMAGEN : IROStream read GetIMAGENValue write SetIMAGENValue;
    property OldIMAGEN : IROStream read GetOldIMAGENValue;
    property COMISIONABLE : Integer read GetCOMISIONABLEValue write SetCOMISIONABLEValue;
    property OldCOMISIONABLE : Integer read GetOldCOMISIONABLEValue;
    property FECHA_ALTA : DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property OldFECHA_ALTA : DateTime read GetOldFECHA_ALTAValue;
    property FECHA_MODIFICACION : DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property OldFECHA_MODIFICACION : DateTime read GetOldFECHA_MODIFICACIONValue;
    property USUARIO : String read GetUSUARIOValue write SetUSUARIOValue;
    property OldUSUARIO : String read GetOldUSUARIOValue;
    property REFERENCIA_PROV : String read GetREFERENCIA_PROVValue write SetREFERENCIA_PROVValue;
    property OldREFERENCIA_PROV : String read GetOldREFERENCIA_PROVValue;
    property PRECIO_COSTE : Float read GetPRECIO_COSTEValue write SetPRECIO_COSTEValue;
    property OldPRECIO_COSTE : Float read GetOldPRECIO_COSTEValue;
    property PRECIO_PORTE : Float read GetPRECIO_PORTEValue write SetPRECIO_PORTEValue;
    property OldPRECIO_PORTE : Float read GetOldPRECIO_PORTEValue;
    property DESCUENTO : Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property OldDESCUENTO : Float read GetOldDESCUENTOValue;
    property PRECIO_NETO : Float read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property OldPRECIO_NETO : Float read GetOldPRECIO_NETOValue;
    property ID_PROVEEDOR : Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property OldID_PROVEEDOR : Integer read GetOldID_PROVEEDORValue;
    property INVENTARIABLE : Integer read GetINVENTARIABLEValue write SetINVENTARIABLEValue;
    property OldINVENTARIABLE : Integer read GetOldINVENTARIABLEValue;
    property NOMBRE_PROVEEDOR : String read GetNOMBRE_PROVEEDORValue write SetNOMBRE_PROVEEDORValue;
    property OldNOMBRE_PROVEEDOR : String read GetOldNOMBRE_PROVEEDORValue;
    property ELIMINADO : Integer read GetELIMINADOValue write SetELIMINADOValue;
    property OldELIMINADO : Integer read GetOldELIMINADOValue;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers;

{ TArticulosBusinessProcessorRules }
constructor TArticulosBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TArticulosBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TArticulosBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosID];
end;

function TArticulosBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosID];
end;

procedure TArticulosBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosID] := aValue;
end;

function TArticulosBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosID_EMPRESA];
end;

function TArticulosBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosID_EMPRESA];
end;

procedure TArticulosBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosID_EMPRESA] := aValue;
end;

function TArticulosBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosREFERENCIA];
end;

function TArticulosBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosREFERENCIA];
end;

procedure TArticulosBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosREFERENCIA] := aValue;
end;

function TArticulosBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosDESCRIPCION];
end;

function TArticulosBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosDESCRIPCION];
end;

procedure TArticulosBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosDESCRIPCION] := aValue;
end;

function TArticulosBusinessProcessorRules.GetFAMILIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosFAMILIA];
end;

function TArticulosBusinessProcessorRules.GetOldFAMILIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosFAMILIA];
end;

procedure TArticulosBusinessProcessorRules.SetFAMILIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosFAMILIA] := aValue;
end;

function TArticulosBusinessProcessorRules.GetIMAGENValue: IROStream;
begin
  result := NewROStream();
  WriteVariantBinaryToBinary(BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosIMAGEN], result.Stream);
end;

function TArticulosBusinessProcessorRules.GetOldIMAGENValue: IROStream;
begin
  result := NewROStream();
  WriteVariantBinaryToBinary(BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosIMAGEN], result.Stream);
end;

procedure TArticulosBusinessProcessorRules.SetIMAGENValue(const aValue: IROStream);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosIMAGEN] := VariantBinaryFromBinary(aValue.Stream);
end;

function TArticulosBusinessProcessorRules.GetCOMISIONABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosCOMISIONABLE];
end;

function TArticulosBusinessProcessorRules.GetOldCOMISIONABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosCOMISIONABLE];
end;

procedure TArticulosBusinessProcessorRules.SetCOMISIONABLEValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosCOMISIONABLE] := aValue;
end;

function TArticulosBusinessProcessorRules.GetFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosFECHA_ALTA];
end;

function TArticulosBusinessProcessorRules.GetOldFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosFECHA_ALTA];
end;

procedure TArticulosBusinessProcessorRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosFECHA_ALTA] := aValue;
end;

function TArticulosBusinessProcessorRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosFECHA_MODIFICACION];
end;

function TArticulosBusinessProcessorRules.GetOldFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosFECHA_MODIFICACION];
end;

procedure TArticulosBusinessProcessorRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosFECHA_MODIFICACION] := aValue;
end;

function TArticulosBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosUSUARIO];
end;

function TArticulosBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosUSUARIO];
end;

procedure TArticulosBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosUSUARIO] := aValue;
end;

function TArticulosBusinessProcessorRules.GetREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosREFERENCIA_PROV];
end;

function TArticulosBusinessProcessorRules.GetOldREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosREFERENCIA_PROV];
end;

procedure TArticulosBusinessProcessorRules.SetREFERENCIA_PROVValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosREFERENCIA_PROV] := aValue;
end;

function TArticulosBusinessProcessorRules.GetPRECIO_COSTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosPRECIO_COSTE];
end;

function TArticulosBusinessProcessorRules.GetOldPRECIO_COSTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosPRECIO_COSTE];
end;

procedure TArticulosBusinessProcessorRules.SetPRECIO_COSTEValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosPRECIO_COSTE] := aValue;
end;

function TArticulosBusinessProcessorRules.GetPRECIO_PORTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosPRECIO_PORTE];
end;

function TArticulosBusinessProcessorRules.GetOldPRECIO_PORTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosPRECIO_PORTE];
end;

procedure TArticulosBusinessProcessorRules.SetPRECIO_PORTEValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosPRECIO_PORTE] := aValue;
end;

function TArticulosBusinessProcessorRules.GetDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosDESCUENTO];
end;

function TArticulosBusinessProcessorRules.GetOldDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosDESCUENTO];
end;

procedure TArticulosBusinessProcessorRules.SetDESCUENTOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosDESCUENTO] := aValue;
end;

function TArticulosBusinessProcessorRules.GetPRECIO_NETOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosPRECIO_NETO];
end;

function TArticulosBusinessProcessorRules.GetOldPRECIO_NETOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosPRECIO_NETO];
end;

procedure TArticulosBusinessProcessorRules.SetPRECIO_NETOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosPRECIO_NETO] := aValue;
end;

function TArticulosBusinessProcessorRules.GetINVENTARIABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosINVENTARIABLE];
end;

function TArticulosBusinessProcessorRules.GetOldINVENTARIABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosINVENTARIABLE];
end;

procedure TArticulosBusinessProcessorRules.SetINVENTARIABLEValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosINVENTARIABLE] := aValue;
end;

function TArticulosBusinessProcessorRules.GetID_PROVEEDORValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosID_PROVEEDOR];
end;

function TArticulosBusinessProcessorRules.GetOldID_PROVEEDORValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosID_PROVEEDOR];
end;

procedure TArticulosBusinessProcessorRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosID_PROVEEDOR] := aValue;
end;

function TArticulosBusinessProcessorRules.GetNOMBRE_PROVEEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosNOMBRE_PROVEEDOR];
end;

function TArticulosBusinessProcessorRules.GetOldNOMBRE_PROVEEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosNOMBRE_PROVEEDOR];
end;

procedure TArticulosBusinessProcessorRules.SetNOMBRE_PROVEEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosNOMBRE_PROVEEDOR] := aValue;
end;

function TArticulosBusinessProcessorRules.GetELIMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosELIMINADO];
end;

function TArticulosBusinessProcessorRules.GetOldELIMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosELIMINADO];
end;

procedure TArticulosBusinessProcessorRules.SetELIMINADOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosELIMINADO] := aValue;
end;


{ TArticulos_RefreshBusinessProcessorRules }
constructor TArticulos_RefreshBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TArticulos_RefreshBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TArticulos_RefreshBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshID];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshID];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshID] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshID_EMPRESA];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshID_EMPRESA];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshID_EMPRESA] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshFECHA_ALTA];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshFECHA_ALTA];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshFECHA_ALTA] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshFECHA_MODIFICACION];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshFECHA_MODIFICACION];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshFECHA_MODIFICACION] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshREFERENCIA_PROV];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshREFERENCIA_PROV];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetREFERENCIA_PROVValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshREFERENCIA_PROV] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetPRECIO_COSTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshPRECIO_COSTE];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldPRECIO_COSTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshPRECIO_COSTE];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetPRECIO_COSTEValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshPRECIO_COSTE] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetPRECIO_PORTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshPRECIO_PORTE];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldPRECIO_PORTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshPRECIO_PORTE];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetPRECIO_PORTEValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshPRECIO_PORTE] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshDESCUENTO];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshDESCUENTO];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetDESCUENTOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshDESCUENTO] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetPRECIO_NETOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshPRECIO_NETO];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldPRECIO_NETOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshPRECIO_NETO];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetPRECIO_NETOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshPRECIO_NETO] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetINVENTARIABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshINVENTARIABLE];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldINVENTARIABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshINVENTARIABLE];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetINVENTARIABLEValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshINVENTARIABLE] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetID_PROVEEDORValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshID_PROVEEDOR];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldID_PROVEEDORValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshID_PROVEEDOR];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshID_PROVEEDOR] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetNOMBRE_PROVEEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshNOMBRE_PROVEEDOR];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldNOMBRE_PROVEEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshNOMBRE_PROVEEDOR];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetNOMBRE_PROVEEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshNOMBRE_PROVEEDOR] := aValue;
end;

function TArticulos_RefreshBusinessProcessorRules.GetELIMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshELIMINADO];
end;

function TArticulos_RefreshBusinessProcessorRules.GetOldELIMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_Articulos_RefreshELIMINADO];
end;

procedure TArticulos_RefreshBusinessProcessorRules.SetELIMINADOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_Articulos_RefreshELIMINADO] := aValue;
end;


{ TArticulosParaClienteBusinessProcessorRules }
constructor TArticulosParaClienteBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TArticulosParaClienteBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TArticulosParaClienteBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteID];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteID];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteID] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteID_EMPRESA];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteID_EMPRESA];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteID_EMPRESA] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteREFERENCIA];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldREFERENCIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteREFERENCIA];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetREFERENCIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteREFERENCIA] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteDESCRIPCION];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteDESCRIPCION];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteDESCRIPCION] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetFAMILIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteFAMILIA];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldFAMILIAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteFAMILIA];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetFAMILIAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteFAMILIA] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetIMAGENValue: IROStream;
begin
  result := NewROStream();
  WriteVariantBinaryToBinary(BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteIMAGEN], result.Stream);
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldIMAGENValue: IROStream;
begin
  result := NewROStream();
  WriteVariantBinaryToBinary(BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteIMAGEN], result.Stream);
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetIMAGENValue(const aValue: IROStream);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteIMAGEN] := VariantBinaryFromBinary(aValue.Stream);
end;

function TArticulosParaClienteBusinessProcessorRules.GetCOMISIONABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteCOMISIONABLE];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldCOMISIONABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteCOMISIONABLE];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetCOMISIONABLEValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteCOMISIONABLE] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteFECHA_ALTA];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldFECHA_ALTAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteFECHA_ALTA];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteFECHA_ALTA] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteFECHA_MODIFICACION];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldFECHA_MODIFICACIONValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteFECHA_MODIFICACION];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteFECHA_MODIFICACION] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteUSUARIO];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldUSUARIOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteUSUARIO];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetUSUARIOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteUSUARIO] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteREFERENCIA_PROV];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldREFERENCIA_PROVValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteREFERENCIA_PROV];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetREFERENCIA_PROVValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteREFERENCIA_PROV] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetPRECIO_COSTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClientePRECIO_COSTE];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldPRECIO_COSTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClientePRECIO_COSTE];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetPRECIO_COSTEValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClientePRECIO_COSTE] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetPRECIO_PORTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClientePRECIO_PORTE];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldPRECIO_PORTEValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClientePRECIO_PORTE];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetPRECIO_PORTEValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClientePRECIO_PORTE] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteDESCUENTO];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldDESCUENTOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteDESCUENTO];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetDESCUENTOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteDESCUENTO] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetPRECIO_NETOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClientePRECIO_NETO];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldPRECIO_NETOValue: Float;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClientePRECIO_NETO];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetPRECIO_NETOValue(const aValue: Float);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClientePRECIO_NETO] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetID_PROVEEDORValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteID_PROVEEDOR];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldID_PROVEEDORValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteID_PROVEEDOR];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteID_PROVEEDOR] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetINVENTARIABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteINVENTARIABLE];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldINVENTARIABLEValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteINVENTARIABLE];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetINVENTARIABLEValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteINVENTARIABLE] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetNOMBRE_PROVEEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteNOMBRE_PROVEEDOR];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldNOMBRE_PROVEEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteNOMBRE_PROVEEDOR];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetNOMBRE_PROVEEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteNOMBRE_PROVEEDOR] := aValue;
end;

function TArticulosParaClienteBusinessProcessorRules.GetELIMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteELIMINADO];
end;

function TArticulosParaClienteBusinessProcessorRules.GetOldELIMINADOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ArticulosParaClienteELIMINADO];
end;

procedure TArticulosParaClienteBusinessProcessorRules.SetELIMINADOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ArticulosParaClienteELIMINADO] := aValue;
end;


initialization
  RegisterBusinessProcessorRules(RID_ArticulosDelta, TArticulosBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_Articulos_RefreshDelta, TArticulos_RefreshBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_ArticulosParaClienteDelta, TArticulosParaClienteBusinessProcessorRules);

end.
